Last Comment Bug 607295 - Provide UI for new archive granularity and folder structure options
: Provide UI for new archive granularity and folder structure options
Status: RESOLVED FIXED
:
Product: Thunderbird
Classification: Client Software
Component: Account Manager (show other bugs)
: Trunk
: All All
: -- enhancement with 2 votes (vote)
: Thunderbird 5.0b1
Assigned To: Jim Porter (:squib)
:
:
Mentors:
Depends on: 517514 542998 652670 654402 657218 657446
Blocks: 473212
  Show dependency treegraph
 
Reported: 2010-10-26 07:15 PDT by rsx11m
Modified: 2011-06-14 10:30 PDT (History)
36 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
UI for archive granularity (100.03 KB, image/png)
2011-02-28 00:23 PST, Jim Porter (:squib)
clarkbw: ui‑review+
Details
Add UI for archive granularity (no tests yet) (32.03 KB, patch)
2011-03-28 17:51 PDT, Jim Porter (:squib)
mozilla: feedback+
Details | Diff | Splinter Review
SM fix (4.46 KB, patch)
2011-03-29 15:39 PDT, Jens Hatlak (:InvisibleSmiley)
no flags Details | Diff | Splinter Review
New UI (78.28 KB, image/png)
2011-04-12 00:41 PDT, Jim Porter (:squib)
clarkbw: ui‑review+
Details
UI with and without groupboxes (31.92 KB, image/png)
2011-04-12 17:07 PDT, Jim Porter (:squib)
bwinton: ui‑review-
Details
Add UI for archive granularity + tests (46.01 KB, patch)
2011-04-13 18:59 PDT, Jim Porter (:squib)
no flags Details | Diff | Splinter Review
Fix a string (46.05 KB, patch)
2011-04-13 20:36 PDT, Jim Porter (:squib)
mozilla: review+
Details | Diff | Splinter Review
Fix review comments (46.29 KB, patch)
2011-04-16 00:34 PDT, Jim Porter (:squib)
squibblyflabbetydoo: review+
bwinton: ui‑review+
Details | Diff | Splinter Review
cut off on Win7 (77.61 KB, image/png)
2011-04-26 13:28 PDT, Jens Hatlak (:InvisibleSmiley)
no flags Details

Description rsx11m 2010-10-26 07:15:00 PDT
Originally I had opened bug 517514 for this, but it ended up only taking care of backend changes from server-specific to per-identity setting, hence I'm opening this bug as a clone to actually take care of the actual user interface.

(Quoting bug 517514 comment #0)
> +++ This bug was initially created as a clone of Bug #486827 +++
> 
> Spun off per bug 486827 comment #19 to provide an easier access to the
> archive_granularity attribute for a server. A possible location would be
> the Copies & Folders page of the Account Manager, e.g., as a drop-down
> menu right underneath the selector for the Archives folder location.
> 
> Possible values of archive_granularity:
> 
> 0 = Flat archive (no subfolders)
> 1 = subfolders in Archives for year (1-level structure, default)
> 2 = subfolders for year, then for month (2-level structure)

With a draft patch by mkmelin in attachment 407331 [details] [diff] [review] (screenshot
provided in attachment 403820 [details]) which could be used as starting point.
 
After some discussion, the following more comprehensive idea from clarkbw:

(Quoting bug 517514 comment #6)
> I was going to suggestion a new dialog window for this.  For reasons of having
> more room to explain the choices given as well as giving space for extensions
> to offer alternate archiving patterns.
> 
> Basic proposal would be this:
> 
> * replace the Archive Hierarchy radios with an ( Archive Options... ) button
> 
> * create new dialog window with the radio buttons and examples near by.
> 
> +-------------------------------+
> |
> | (o) Flat Folder
> |     /Archives/
> |
> | (o) Yearly Archived Folders
> |     /[-] Archives/
> |       |--- 2009
> |       +--- 2008
> |
> | (o) Yearly Archived Folders
> |     /[-] Archives/
> |       |--[-] 2009
> |       |   |--- 2
> |       |   +--- 1
> |       +--[-] 2008
> |           |--- 12
> |           +--- 11
> |
> +-------------------------------+
> 
> I think we might actually want the examples beside the radio buttons but that
> was harder to do in ascii art.  For these types the examples could all be done
> in JS such that the year and folder are close to current.
> 
> Future Archive schemes provided via extensions could just append to that dialog
> for their options.
Comment 1 David :Bienvenu 2010-10-26 07:21:07 PDT
There's also an option to keep the original folder structure in the archives hierarchy that we may want a UI for - controlled by "mail.identity.default.archive_keep_folder_structure
Comment 2 sunk818 2011-01-05 20:15:15 PST
Hi, as a user, I would only provide feedback that if you want to use YYYY/MM format for archive granularity option 2, that you use a leading 0 for the first nine months. Otherwise, the sorting will look odd. Thanks again for your all your hard work and dedication. After using Microsoft Outlook for over ten years, I am very happy with Mozilla Thunderbird and will not be looking back.
Comment 3 Jens Hatlak (:InvisibleSmiley) 2011-01-06 13:52:55 PST
(In reply to comment #2)
> Hi, as a user, I would only provide feedback that if you want to use YYYY/MM
> format for archive granularity option 2, that you use a leading 0 for the first
> nine months.

Option 2 implies the YYYY-MM format (dash, not slash) for the second-level folder name and (already) includes a left zero-padding for MM (like printf %02d).
Comment 4 Jim Porter (:squib) 2011-02-28 00:23:45 PST
Created attachment 515572 [details]
UI for archive granularity

I've got a patch for this in progress. Here's the UI, which doesn't do a whole lot yet. Note that this builds on bug 542998 to allow disabling archiving entirely.

Maybe we should move the archive options in Copies & Folders to its own group, since it's not really the same as drafts or templates, which are about composing. It's more obvious that they're different now that the archive options have different controls.
Comment 5 Jim Porter (:squib) 2011-02-28 00:24:32 PST
Oh also there's a typo in that screenshot. It should say "Monthly archived folders".
Comment 6 Bryan Clark (DevTools PM) [@clarkbw] 2011-03-01 14:44:44 PST
Comment on attachment 515572 [details]
UI for archive granularity

(In reply to comment #4)
> Created attachment 515572 [details]
> UI for archive granularity

Looks really good.
 
> I've got a patch for this in progress. Here's the UI, which doesn't do a whole
> lot yet. Note that this builds on bug 542998 to allow disabling archiving
> entirely.

That seems like a good top level option.

> Maybe we should move the archive options in Copies & Folders to its own group,
> since it's not really the same as drafts or templates, which are about
> composing. It's more obvious that they're different now that the archive
> options have different controls.

Agreed, perhaps something like.

[x] Enable Message Archiving                 ( Archive options... )

Two nits:
* Might want to name the title of the dialog "Archive Options".
* "Keep existing folder structure of archived messages"
Comment 7 Bryan Clark (DevTools PM) [@clarkbw] 2011-03-01 14:48:23 PST
Also.  I'm a bit unsure what we do as people switch archive systems.  I assume that most people would expect the archive folders would mirror whatever option they choose.  However I know this would take, essentially re-archiving everything, a bit of cpu and disk time.  

We should figure out how we want to either inform the user how the change will take place or look into making the change more automatic.  Lots of questions.
Comment 8 Jim Porter (:squib) 2011-03-01 14:51:56 PST
(In reply to comment #7)
> We should figure out how we want to either inform the user how the change will
> take place or look into making the change more automatic.  Lots of questions.

True. This is part of why I want to hook up the archive options dialog to the archive first-use message in bug 511741, so that people can set up how they want to archive before any archiving actually happens. Obviously, that's not the best solution, since it doesn't make it easy to change after the fact, but it would help.
Comment 9 Jim Porter (:squib) 2011-03-01 17:58:24 PST
(In reply to comment #6)
> > Maybe we should move the archive options in Copies & Folders to its own group,
> > since it's not really the same as drafts or templates, which are about
> > composing. It's more obvious that they're different now that the archive
> > options have different controls.
> 
> Agreed, perhaps something like.
> 
> [x] Enable Message Archiving                 ( Archive options... )

I tried to keep the wording of the checkbox similar to the one for sent mail (and similar to the labels for the drafts and templates settings), but if I do that, I find myself reading the UI like "Keep message archives in -- Archive options -- "Archives" folder on...", and that's how I imagine a screen reader would do it too.

Originally, I had put the Archive options button at the bottom to mimic the "Message synchronizing" layout, though putting it there uses up more vertical space.
Comment 10 Jim Porter (:squib) 2011-03-28 17:51:50 PDT
Created attachment 522543 [details] [diff] [review]
Add UI for archive granularity (no tests yet)

Here's a patch to add some UI for this. I'm not totally sure what we need for tests with this; how defaults get inherited for identities is a mystery to me. Ideas?
Comment 11 Jens Hatlak (:InvisibleSmiley) 2011-03-29 15:39:20 PDT
Created attachment 522829 [details] [diff] [review]
SM fix

(In reply to comment #10)
> Created attachment 522543 [details] [diff] [review]
> Add UI for archive granularity (no tests yet)
> 
> Here's a patch to add some UI for this.

I tried this on SeaMonkey trunk and found the DTD files were out of sync. The attached patch fixes that and reorders the TB part so that the comments are directly above the labels they describe again. [No need for attribution, just incorporate it into your version please.]

I'm on Win7 and there both the Copies & Folders pane and the Archive options dialog that can be opened were cut off at the bottom. The latter is not too serious and can be fixed easily (just make the dialog taller), but the former really is an issue because the "Show confirmation dialog when messages are saved" line is not visible at all. Unfortunately it's not obvious where we can save space there, and I don't know whether making the window taller is an option.

> how defaults get inherited for identities is a mystery to me.

For boolean prefs you can see it here:
<http://mxr.mozilla.org/comm-central/source/mailnews/base/util/nsMsgIdentity.cpp#487>

So basically the back-end uses the value of the "default" identity pref for boolean identity properties if no value for the actual identity has been defined (= user pref set).
Comment 12 David :Bienvenu 2011-03-30 14:12:06 PDT
Comment on attachment 522543 [details] [diff] [review]
Add UI for archive granularity (no tests yet)

I love that you're showing examples of the archive hierarchy, but it's weird that the folders are selectable in the list boxes. Also, I think an example of what "keep folder structure" will do would be nice since it's a bit ambiguous.

Also, do you mean to comment this out? If so, you might just instead put a comment as to why you're not copying the archive settings.

+/*    COPY_IDENTITY_BOOL_VALUE(identity,GetArchiveEnabled,SetArchiveEnabled)
+    COPY_IDENTITY_INT_VALUE(identity,GetArchiveGranularity,
+                            SetArchiveGranularity)
+    COPY_IDENTITY_BOOL_VALUE(identity,GetArchiveKeepFolderStructure,
+    SetArchiveKeepFolderStructure)*/
Comment 13 Jean-Marie COUPRIE 2011-04-04 10:06:34 PDT
If I have well understood the archive function of Thunderbird 3 (http://www.mozillamessaging.com/en-US/thunderbird/features/#secure-protect Message Archive), I choose a mailbox, select some messages (e.g. older than a year) and call the archive function (button or shortcut). Now those messages disappear from the mailbox and go to a folder that I have defined here. The purpose and the advantage of this function is that it decrease the size of the current mailbox : it is faster to manipulate smaller files (POP or IMAP) and if the archives folders are out of the space mirrored on the IMAP server it relieves quota problems.
 There are other functions useful to decrease the size e.g. detaching the attachments from "inbox" or erasing them from "sent" mailboxes, creating user defined mailboxes (filling them using filters) : this distribute to total size in many parts.


I need several UIs to use the archive function :
Of course, the UI reflects what the user wish to do. So before discussing UIs we have to discuss the uses.

1) Definition of archive folders and their structure and content.
-The "archived" contents are what I don't need to keep in the "current" mailboxes with fast and permanent access. Many actions are repeated each year : Xmas, New Year and birthdays have fixed dates but Easter, summer or winter vacations have moving dates so I think that I have to keep a full year plus a margin (something between 365 and 465 days). This does not cause problems for me because my accounts have a big quota (1 GO. or more) and I don't receive too many mails/accounts. With smaller quota or plenty of mails I may have chosen a shorter time.
-Structure of archived folders : from above, I'll choose the "Yearly Archived Folders" with the option "to keep the original folder structure in the archives hierarchy" because I am happy with my present structure of many mailboxes that make easy to find a message and I wish to have the same structure in the archive. I need clarifications : if I have selected a range of messages encompassing 2 years (e.g. 2008 and 2009) does the messages go to the year of their dates or to the year of the archiving command (difficult to accept)? What about xxx.msf files that are the indexes of xxx mailboxes ?
-I'll consider the archived folders as a back-up. That means several things : archiving should be a very secure process probably appending to a temporary file containing a copy of the already existing archive folder and renaming at the last second (I think that a similar method is used when compacting mailboxes), the destination folder has to be on an external disk that is not permanently connected or powered-on (to avoid destruction when my PC is destroyed by a catastrophic event). It should also include the name of the account.
-How many times the archiving function should be repeated ? With "Yearly Archived Folders" I assume that archiving once a month is sufficient. How many mailboxes do I have to archive ? Five mailboxes are defined at the creation of each account but user can define many others and move to them the incoming mail (automatically by filters) and even the outgoing mail (manually by filters). Inbox and Sent may be big and have to be archived periodically, so are user defined mailboxes, Drafts should be small or empty, Junk or Trash can be periodically erased. Templates are created when a first message is saved as template ; It is normally small and you keep it available without archiving it. That means at least 2 mailboxes to archive per account. In my particular case, I have 8 accounts with a total of 241 mailboxes out of which approximatively 220 are to be archived. I think that archiving mailbox by mailbox (as presently defined) is acceptable up to a dozen of times but becomes a show stopper at 2 dozens or more. So a more powerful method e.g. archiving account by account is needed : an idea is to archive all the messages that are older than xxx days for all the mailboxes of the account with only 1 command. An UI may be to apply the presently defined function when a mailbox is selected and the more powerful method when an account is selected.
-I'll have to back-up the "current" mailboxes periodically as all other files of my disk. As archiving may change dormant mailboxes by suppressing old messages, I have no interest in archiving too often (e.g each day instead each month). 

2) I need to access or search the archived folders.
How ? Which is the UI ?
The ideal solution is that they can be accessed or searched the same way as the "current" (not archived) mailboxes. The possibility of moving/copying a message from an archived mailbox to an other (archived or not) allow to correct an error of location or to undo archiving.

3) There is a particular account : the one specialized to receive my subscriptions to forums, bugzilla, newsletters, etc. .
 Why specialized ? because the corresponding userid is rapidly spammed so I use a Gmail account which have a very effective spam protection. Some sites do not apply the anti-spam rule to never publish user mail address (e.g. bugzilla, developers forums, etc.), other may sell addresses (I have not the proof) or be compromised.
 Why particular ? because I do not need to keep all the messages saying that a particular bug or forum has been modified : the last one is sufficient. A newsletter that is more than 3 to 6 months old has no more interest.
 Can erasing messages be considered as archiving ? Yes, it is archiving in a "garbage can" folder (the thrash mailbox) common to the whole account...
 What function do I need ? When the mailbox is used for newsletter(s), I need, per subject (in case the same mailbox is used for several), the last occurrence and all the others that are more recent that xxx days. For notification that a particular bug or forum has been modified I need to keep only the most recent occurrence of each subject (in case the same mailbox is used for several bugs or forums). To summarize, I need, per subject, the last occurrence and all the others that are more recent that xxx days, xxx being equal to 1 in some cases and changing with the mailbox.
Can this function be added in the UI or is an other bug needed ?
Comment 14 IagoSRL 2011-04-04 12:34:15 PDT
Hi Jean-Marie COUPRIE,
 The features you describe are like the 'autoarchive' feature that MS-Oulook product has: this let you define default archive settings -for all selected folder- and specific settings per folder; you can start manually the task and/or scheduling it, only press a button and all folders will be reviewed and old mail archived; also let you define 'delete' instead 'archive' action, useful to special folders. It's an interesting feature that I want to see in Thunderbird (and more people), the current archive feature is a starting point but there is too much work to do, step by step; but there is something really great in the current Thunderbird archive feature -that Oulook have not, almost version 2003 I know-: create automatically folders per year and month (if you want, just this bug is about how the user can configure it!) and send the mails into the appropriated folder -if you select messages with different year and/or month and press the archive button each message goes to its respective folder, separately (works fine!)-.

 Please, see the Bug 93094, is about the 'auto archive' feature similar to Outlook and more; the Comment 3 in that bug explain better than me ;).

 At my work, archive automatically old mail to the local folders is very important (time cannot be wasted doing manually this task with the great amount of mail that we manage); Oulook is widely used but some colleagues and me are migrating to Thunderbird and I built a extension that do the autoarchive task; it have very limited settings, work fine for us but need more work; I expect do a public release after correct some things; my problem is that currently I have not time to enhance it :(
Comment 15 Mitra Ardron 2011-04-04 15:54:15 PDT
I hope that this bug doesn't get diverted from simply offering a UI on the granularity - automatic archiving has its values, but I suggest that people's needs are different enough that it should first be extensions that people can try until it becomes clear what is wanted. 

For example ... presonally I use the "A" button to archive messages I've dealt with so want cleared from my inbox - but still want to be able to search, refer to etc, while the "Delete" button is for messages that I really want to delete (including older messages in a chain of responses, junk, etc). 

One UI feature I'd like on granularity is to be able to use a Yearly folder for previous years, and Monthly for the last 12 months. The reason for this is the integration with backup, if I use Yearly for everything then my entire year's archived email (typically 1GB) is backed up every time Time Machine runs (hourly) and clogs the disk.  Doing this for monthly files is much more reasonable.
Comment 16 rsx11m 2011-04-04 18:12:46 PDT
Yes, this bug is *exclusively* about adding a UI for the two preferences stated, nothing else. Please comment on the respective bugs for other topics, and use forums and newsgroups for any general discussions on this topic. Thanks.
Comment 17 Jean-Marie COUPRIE 2011-04-08 07:27:22 PDT
To IagoSRL
You are right, I'll move my comment 13 to Bug 93094
Comment 18 Jean-Marie COUPRIE 2011-04-08 08:39:50 PDT
The archive function is distributed in several bugs.
To avoid posting in a wrong place, I suggest that each of them contains the full list. Searching on "archiv" I have found :
Bug 473212 - tracking bug for finishing Archive feature in TB 
Bug 479823 - Archive function: archive filter rules 
Bug 481185 - Remove all attachment when Archiving 
Bug 639466 - Automatic archiving as retention policy 
Bug 93094 - [RFE] Add an archive mail feature (automatic archiving of messages per month /other interval) 
Bug 561617 - Add Semester and Quaterly Archive possibility 
Bug 607295 - Provide UI for new archive granularity and folder structure options
Comment 19 Jean-Marie COUPRIE 2011-04-08 09:19:44 PDT
From my previous comment 13 only remains :
-The present bug solve only the case of users without user defined mailboxes or having only a very small number of them. Further work is required for others see bugs 93094 or 473212 .
-Please confirm that if I choose the "Yearly Archived Folders" with the option "to keep the original folder structure in the archives hierarchy" I can have something like :
X:\TB\account_name\YYYY\inbox
X:\TB\account_name\YYYY\sent
X:\TB\account_name\YYYY\my_mailbox_1
....................................
X:\TB\account_name\YYYY\my_mailbox_n
where X: is an external disk, and TB\account_name\ is my choice of subdirectory.
-if I have selected a range of messages encompassing 2 years (e.g. 2008 and 2009) does the messages go to the year of their dates or to the year of the archiving command (this seems difficult to accept)?
- What about xxx.msf files that are the indexes of xxx mailboxes ? archived or not ? They are reconstructed if missing.
Comment 20 rsx11m 2011-04-08 09:24:33 PDT
(In reply to comment #18)
> Bug 473212 - tracking bug for finishing Archive feature in TB 

That's why there are those tracking ("meta") bugs, associating related bugs
with each other (which reminds me that this specific bug - and probably others
in your list - should be blocking that meta bug; so done for this one, thanks).

Question for Bryan or Jim re comment #19, is there some way to let the example page change when the "Keep folder structure" option is checked to make it clear for the user what it implies? SeaMonkey might be able to explain that more in detail in their Help content, but Thunderbird doesn't have a help viewer, so that would have to be self-contained. I wouldn't consider that a blocker, but would be nice to have to help the user understand the feature.
Comment 21 Jean-Marie COUPRIE 2011-04-11 09:31:59 PDT
(In reply to Comment 20) "Help"

After pressing PF1 on Thunderbird (or ? then help), Firefox show me 
http://support.mozillamessaging.com/En-US/kb/
which is : Thunderbird Knowledge Base, I enter "archive" in the search box to go to
http://support.mozillamessaging.com/tiki-searchresults.php?locale=en-US&q=archive&sa=
I click on "Archived messages" to obtain URL
http://support.mozillamessaging.com/en-US/kb/Archived+messages
which may be considered as a minimal "help" like info for the present functionality.

Please enter an update of it (as an attachment here) with the new UI screen and some text to explain what is obtained with the various choices.
This may replace the present "help" when the bug is released and presently answer many of our questions.
Comment 22 Jim Porter (:squib) 2011-04-11 15:04:23 PDT
One option would be to have a single example <tree> that changes as you select different options. That way, it would be totally clear what all six possible combinations look like without using up space for six examples.
Comment 23 Jim Porter (:squib) 2011-04-11 15:05:51 PDT
The downside of doing that would be that, if a user were confused about what the descriptions meant, he'd have to click through until he found a setting he liked. (On the other hand, the descriptions are pretty clear to me, so hopefully people would only need to see the example as a way of confirming their choice.)
Comment 24 Jim Porter (:squib) 2011-04-12 00:41:26 PDT
Created attachment 525324 [details]
New UI

Since there's not enough space for six different examples (3 granularities * 2 keep/don't keep folder structure), I changed things around to use a single example <tree>. For completeness, here are all the possible states of the dialog.
Comment 25 Bryan Clark (DevTools PM) [@clarkbw] 2011-04-12 11:57:33 PDT
Comment on attachment 525324 [details]
New UI

Looks good.  Only suggestion is that you line up the checkbox option with the header text (When archiving...) instead of with the radio buttons.
Comment 26 Jim Porter (:squib) 2011-04-12 12:39:34 PDT
Right now, it's a group box, which Ubuntu doesn't seem to draw a border for. I guess there are a couple options:

##### Option 1 #####

+- Archive Options ---------------------------+
| When archiving messages, place them in:     |
|  o A single folder                          |
|  o Yearly archived folders                  |
|  o Monthly archive folders                  |
| X Keep exiting folder structure of archived |
|   messages                                  |
+---------------------------------------------+

+- Example -----------------------------------+
| +-----------------------------------------+ |
| | v X Archives                            | |
| |   v 2010                                | |
| |       11                                | |
| |       12                                | |
| |   v 2011                                | |
| |       01                                | |
| |       02                                | |
| +-----------------------------------------+ |
+---------------------------------------------+

##### Option 2 #####

+- When archiving messages, place them in: ---+
|  o A single folder                          |
|  o Yearly archived folders                  |
|  o Monthly archive folders                  |
+---------------------------------------------+

X Keep exiting folder structure of archived
  messages

+---------------------------------------------+
| v X Archives                                |
|   v 2010                                    |
|       11                                    |
|       12                                    |
|   v 2011                                    |
|       01                                    |
|       02                                    |
+---------------------------------------------+

Or maybe some variant on those?
Comment 27 Bryan Clark (DevTools PM) [@clarkbw] 2011-04-12 14:15:18 PDT
I should probably look at windows but I'd go with option 1.  The Mac only draws a single line at the top.
Comment 28 Jim Porter (:squib) 2011-04-12 14:22:41 PDT
Should I worry about the string "Archive Options" being redundant with the dialog title in option 1? A variant on that would be to do option 1 but to remove the group boxes ("Archive Options" and "Example"). I'm not sure they really add anything, anyway.
Comment 29 Jim Porter (:squib) 2011-04-12 17:07:49 PDT
Created attachment 525562 [details]
UI with and without groupboxes

Just to be totally sure, here's what it looks like with and without the groupboxes. I think the second one (with the groupbox) looks better, though maybe a better string would be good too.
Comment 30 Blake Winton (:bwinton) (:☕️) 2011-04-13 06:28:37 PDT
(In reply to comment #29)
> Created attachment 525562 [details]
> UI with and without groupboxes
> 
> Just to be totally sure, here's what it looks like with and without the
> groupboxes. I think the second one (with the groupbox) looks better, though
> maybe a better string would be good too.

Personally, I like the groupbox for the Example, but I think I would skip the groupbox for the options themselves.

Later,
Blake.
Comment 31 Bryan Clark (DevTools PM) [@clarkbw] 2011-04-13 17:07:50 PDT
Comment on attachment 525562 [details]
UI with and without groupboxes

Agreed with Blake here.  All hail the new King!  I'll hand my review over to Blake.

The top group box is just a duplicate to the title so it doesn't add much but you really want to explain what's going on in the box below.
Comment 32 Jim Porter (:squib) 2011-04-13 18:59:30 PDT
Created attachment 525899 [details] [diff] [review]
Add UI for archive granularity + tests

I updated the UI a bit (removed the group box around the options and fixed the month folder names - they should be YYYY-MM) and added some tests. This should be ready for review now.

Notably, I didn't test inheritance/copying of the the archive prefs through multiple identities. However, I think if we tested that, we'd want a more general test (checking all the prefs) instead of a specific one for these particular prefs.
Comment 33 Jim Porter (:squib) 2011-04-13 20:36:12 PDT
Created attachment 525913 [details] [diff] [review]
Fix a string

Whoops, I forgot to change the name of a string since I had changed its value. That's fixed now.
Comment 34 David :Bienvenu 2011-04-15 08:57:51 PDT
Comment on attachment 525913 [details] [diff] [review]
Fix a string

need to fix this:
\ No newline at end of file

4 space indents here:

+{
+    var broadcaster = document.getElementById("broadcaster_archiveEnabled");
+
+    var checked = document.getElementById("identity.archiveEnabled").checked;

we use 2 space indent for new code...

but this looks good otherwise.
Comment 35 Jim Porter (:squib) 2011-04-16 00:34:13 PDT
Created attachment 526461 [details] [diff] [review]
Fix review comments

Review comments fixed. Should we have Seamonkey look at this too, just to be safe?
Comment 36 David :Bienvenu 2011-04-16 06:53:17 PDT
Jens, can you have a quick look at this for SeaMonkey? thx!
Comment 37 Jens Hatlak (:InvisibleSmiley) 2011-04-17 09:16:57 PDT
(In reply to comment #36)
> Jens, can you have a quick look at this for SeaMonkey? thx!

I wonder whether you really wanted to CC the other Jens; luckily I was CC'd already. Tip: Consult the c-c log instead. ;-) Please note that I'm not an official SM reviewer.

Basically the DTD part of my comment 11 has been fixed (thanks for that!) so the new dialog (which is opened from the "Archive options" button) is OK now. Or rather well done!

However, the other issue I found and documented in comment 11 has not been addressed yet. Both with SM's Default theme and the Modern theme, the contents of the Copies & Folders pane exceed the height of the dialog on Windows, so the second groupbox is cut off at the bottom (in the middle of "Other" for templates) and the last checkbox is not visible at all. You can resize the dialog, but that's not obvious (the dialog has no resizer) and there are no scroll bars either. Please have someone check whether TB/Shredder on Windows is affected, too, and whether making the dialog taller is an option (I don't know what the minimum accepted screen size is nowadays), or what else we can do.
Comment 38 rsx11m 2011-04-17 09:49:16 PDT
> (comment #37) Please note that I'm not an official SM reviewer.

Prior to the MailNews-review changes I would have asked Neil for superreview of such changes, don't know what the current rules are (we have Mnyromyr on the CC list as well, so it should get the respective attention by SM as necessary).

> Basically the DTD part of my comment 11 has been fixed (thanks for that!) so
> the new dialog (which is opened from the "Archive options" button) is OK now.
> Or rather well done!

This would be late-l10n for SeaMonkey 2.1, thus important to get in asap...

> Both with SM's Default theme and the Modern theme, the contents
> of the Copies & Folders pane exceed the height of the dialog on Windows

I didn't apply the patch, but relative to attachment 515572 [details] the new
archiveHierarchyButton already moved on the same row as identity.archiveEnabled so it appears to be exactly that one row being a bit too much. SeaMonkey allows you to increase the window manually, btw. (SM 2.1pre on Windows 7), and it may also be a matter of fonts and desktop theme. It seems like that row would fit for me, but it may look differently elsewhere.

In order to get this in timely, maybe spin off any size issues to follow-up bugs as necessary? It appears that not much can be gained by further changing the XUL structure, and it would be good to get at least the strings in.
Comment 39 neil@parkwaycc.co.uk 2011-04-17 16:01:22 PDT
CCing a localiser for input on the l10n impact, but we might be able to work around that by branching c-c this week, releasing 2.1.0 from c-2.0, and then including tweaks such as this in a fast turnaround update.
Comment 40 Robert Kaiser 2011-04-19 11:17:15 PDT
L10n change for SeaMonkey 2.1 isn't really acceptable, but I think we'll solve that by having this landed only on comm-central and not comm-2.0.
Comment 41 Mark Banner (:standard8) 2011-04-19 12:03:39 PDT
SeaMonkey has branched, so we can land in comm-central and it doesn't affect them.
Comment 42 Blake Winton (:bwinton) (:☕️) 2011-04-19 12:42:36 PDT
Comment on attachment 526461 [details] [diff] [review]
Fix review comments

Sorry for the r- on the image, but I really like this implementation better.  :)

My only remaining problem with it is that I either want the twisties in the example to expand and contract the folders, or I'ld like to not be able to highlight the rows (nor have them change colour on hover).

If you decide to let the twisties expand and contract the folders, I strongly suggest that you expand them all when the user switches the settings, so that they can see what the full hierarchy looks like.

Thanks,
Blake.
Comment 43 Jim Porter (:squib) 2011-04-19 12:46:36 PDT
Let me guess, you're using Win Vista/7, right? The rows aren't selectable for me on Linux, and I know that the styles on Vista/7 are being overridden, so those styles probably aren't properly respecting disabled <tree>s.
Comment 44 neil@parkwaycc.co.uk 2011-04-19 13:42:36 PDT
Probably a bug in the native theme code.
Comment 45 Jim Porter (:squib) 2011-04-25 11:48:02 PDT
(In reply to comment #44)
> Probably a bug in the native theme code.

Looks like it might be a bug with Thunderbird's Aero theme, since it overrides some CSS for <tree>s in messenger-aero.css. Everything works right on XP, where these overrides aren't present.

Blake, do you think we could file the Aero theme bug as a followup, since it's going to be difficult at best for me to test that, since I don't have Windows 7 (or Vista for that matter)?
Comment 46 Blake Winton (:bwinton) (:☕️) 2011-04-25 15:06:27 PDT
Yeah, I think we can.  CC Richard Marti (:paenglab) and I on the new bug, and hopefully Richard will have time to fix it up…

Thanks,
Blake.
Comment 47 Jim Porter (:squib) 2011-04-25 17:38:01 PDT
Comment on attachment 526461 [details] [diff] [review]
Fix review comments

Pulling forward r+ from attachment 525913 [details] [diff] [review]
Comment 48 Jim Porter (:squib) 2011-04-26 00:03:52 PDT
Checked in: http://hg.mozilla.org/comm-central/rev/14758a313235
Comment 49 rsx11m 2011-04-26 07:12:12 PDT
Looks nice in the SeaMonkey 2.2a1pre nightly builds. A quick follow-up on this:

> (comment #37) Both with SM's Default theme and the Modern theme, the contents
> of the Copies & Folders pane exceed the height of the dialog on Windows, so the
> second groupbox is cut off at the bottom (in the middle of "Other" for
> templates) and the last checkbox is not visible at all.

With a new profile, I see no issues using the Windows Classic desktop theme on Windows 7. However, with the Windows 7 default theme and a new profile, the last groupbox is missing its lower boundary. All UI items are fully visible and accessible though, so this doesn't seem to pose a practical issue.

There are other Account Settings pages which don't fully fit into the current dialog box with Windows 7 default (though it increases its initial size based on the desktop theme), thus respective SeaMonkey bugs may be pending already.
Comment 50 Jens Hatlak (:InvisibleSmiley) 2011-04-26 13:28:22 PDT
Created attachment 528421 [details]
cut off on Win7

Before anyone thinks I'm hallucinating or that it's SM only: This is with a recent Shredder/Miramar/youNameIt. This is just for posterity since actually addressing this should probably have its own bug anyway.
Comment 51 Thomas Stache 2011-05-03 02:34:28 PDT
Filed bug 654402 to track the clipped layout issue.
Comment 52 sunk818 2011-06-08 11:53:40 PDT
When I upgraded from TB 3.1 to Miramar 3.3 Alpha 3, messages that were not be archived correctly finally worked (I selected YYYY-MM format). Now that I am using TB 5.1 B1, the archive option is not working again.

Also, I am not seeing the (Tools, Account Settings) Archive options... box for second and third mail box both of which are xxx@gmail.com

Also, if I clicked on Copies & Folders on my second or third mail box first, then go click on the first Copies & Folders, the archive options box does not appear.
Comment 53 Jim Porter (:squib) 2011-06-08 11:58:58 PDT
(In reply to comment #52)
> When I upgraded from TB 3.1 to Miramar 3.3 Alpha 3, messages that were not
> be archived correctly finally worked (I selected YYYY-MM format). Now that I
> am using TB 5.1 B1, the archive option is not working again.

I'm guessing you're trying to use a non-flat archiving scheme on Gmail? That's not supported, but it was inadvertently allowed for a short time during the alphas. Non-flat archive hierarchies can "work" on Gmail, but they're a bit strange.

> Also, I am not seeing the (Tools, Account Settings) Archive options... box
> for second and third mail box both of which are xxx@gmail.com
> 
> Also, if I clicked on Copies & Folders on my second or third mail box first,
> then go click on the first Copies & Folders, the archive options box does
> not appear.

Bug 657446.
Comment 54 sunk818 2011-06-14 10:30:19 PDT
> That's not supported, but it was inadvertently allowed for a 
> short time during the alphas.

I unsubscribed from All Mail and set this to false: 

mail.server.default.is_gmail

I don't know the consequences exactly, but my e-mails are archiving the way I want.

Note You need to log in before you can comment on or make changes to this bug.